\\ Copyright 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

allocatemem(300 * 10^6);
default(recover,0);
default(strictargs,1);
read("configurations.gp");
read("recurrence-guess.gp");
iferr(read("configurations-gfs-generated.gp"),e,0);


\\-----------------------------------------------------------------------------
{
  \\ generating functions for all configurations

  rec_length = 2*99+50;
  print("size ",size,"  rec_length ",rec_length);
  my(values = vector(size,i, vector(rec_length)));  \\ vector of vectors

  my(v=initial);
  for(i=1,rec_length,
     for(j=1,size, values[j][i] = v[j]);
     v = m*v);

  if(type(conf_index_to_gf) != "t_VEC",
     print("new file");
     system("rm -f configurations-gfs-generated.gp");
     write("configurations-gfs-generated.gp",
           "\\\\ Generated by configurations-gfs.gp -- DO NOT EDIT\n");
     write("configurations-gfs-generated.gp",
           Strprintf("conf_index_to_gf=vector(if(want_mirror,393,753));\n"));
     conf_index_to_gf = vector(size);
     );

  for(i=1,size,
     if(conf_index_to_gf[i],
        print("already ",i);
        next());

     my(conf = index_to_conf[i],
        gf = recurrence_guess_values_to_gf(values[i]));
     conf_index_to_gf[i] = gf;
     if(want_mirror && gf != 1,
        gf /= 2;
        write("configurations-gfs-generated.gp",
              Strprintf("conf_index_to_gf[conf_to_index(%s)] += %s;\n", conf, gf));
        conf = conf_permute(conf,mirror_perm);
        write("configurations-gfs-generated.gp",
              Strprintf("conf_index_to_gf[conf_to_index(%s)] += %s;\n", conf, gf))
        ,
        
        write("configurations-gfs-generated.gp",
              Strprintf("conf_index_to_gf[conf_to_index(%s)]=%s;\n", conf, gf)));

     my(den = denominator(gf),
        dendeg = poldegree(den));
     print(i," degree ",dendeg,"  time ",elapsed_time());
  );

}

\\-----------------------------------------------------------------------------
{
  \\ no configurations identically equal except initial=1 and ends=0,2,2,2

  rec_length = 100;
  my(values = vector(size,i, vector(rec_length)));  \\ vector of vectors
  print("rec_length ", rec_length);

  my(v=initial);
  for(i=1,rec_length,
     for(j=1,size, values[j][i] = v[j]);
     v = m*v);

  values = vecsort(values);
  for(i=1,#v-1,
     if(values[i] == values[i+1],
        print("equal "i);
        print("  ",values[i][1..10]);
        print("  ",values[i+1][1..10]);
       ));
  quit();
}

