\\ Copyright 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


\\ 4 cycle  11->1->7->6->11

\\ 4 cycle all
m = m=matrix(11,11);
m[1,7]++;
m[6,11] += 2;
m[7,1]++; m[7,6]++;
m[11,1]++;
m[2,2] += 2; m[2,11]++;
m = mattranspose(m);
m

\\ 4 cycle single
\\ m = m=matrix(11,11);
\\ m[1,7]++;
\\ m[6,11] += 1;
\\ m[7,6]++;
\\ m[11,1]++;
\\ m[2,2] += 2; m[2,11]++;
\\ m = mattranspose(m);
\\ m

initial = vectorv(11,i,i==2);
initial = vectorv(11,i,i==11);
gf_column = (matid(11) - m*x)^-1 * initial

read("pol-ascend.gp");
read("pol-pfrac.gp");
for(i=1,#gf_column, pol_ascending_print(gf_column[i]))

print("\n")
for(i=1,#gf_column, \
   print(i); \
   pol_ascending_print(pol_partial_fractions(gf_column[i],I)))

v=initial;
for(i=1,35, \
   print(v[6]); \
   v = m*v; \
);


gf_terms(g,n) = \
  my(x = variable(g), \
     zeros = min(n,valuation(g,x)), \
     v = Vec(g + O(x^n))); \
  if(zeros>=0, concat(vector(zeros,i,0), v), \
               v[-zeros+1 .. #v]);

g(x) = (1/10)/(1 - 2*x) \
 + (1/30 + 1/15*I)/(1 + I*x)\
 + (1/30 - 1/15*I)/(1 - I*x)\
 + (-1/6 - 1/3*x)/(1 - 2*x^2);
gf_terms(g(x),20)


r(k) = 1/10*2^k \
  + (1/30 + 1/15*I)*(-I)^k \
  + (1/30 - 1/15*I)*(I)^k \
  - 1/6 * 2^ceil(k/2);
vector(25,k,r(k-1))

  \\ + if(k%4==0, 1/15) \
  \\ + if(k%4==1, 2/15) \
  \\ + if(k%4==2, -1/15) \
  \\ + if(k%4==3, -2/15) \
 \\ (-1)^floor(k/2)*2^(k%2) \
r(k) = \
  1/10*2^k \
  - 1/6 * 2^ceil(k/2) \
  + 1/15 * (-1)^floor(k/2)*2^(k%2);
vector(25,k,r(k-1))

\\ 0 0 0 0 1 2 4 8 17 34 68 136 273 546 1092

\\ 1 2 5 10 23 46 97 194 399 798 1617
