\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


\\-----------------------------------------------------------------------------
pol_ascending_str__join_strings(v,sep) =
{
  if(#v==0, return(""));
  concat(vector(2*#v-1,i, if(i%2,v[(i+1)\2],sep)));
}

pol_ascending_str(p) =
{
  if(type(p) == "t_VEC",
     return(pol_ascending_str__join_strings(apply(pol_ascending_str,p),
                                             "\n + ")));

  my(d = denominator(p));
  if(poldegree(d) != 0,
     p = numerator(p);
     my(low = polcoeff(d, 0));
     if(low==0, error("Oops, constant term of denominator is 0"));
     d /= low;
     p /= low;
     my(p_single = (poldegree(p) == 0
                    || poldegree(p) == valuation(p,variable(p))));
     my(d_single = (poldegree(d) == 0
                    || poldegree(d) == valuation(d,variable(d))));
     p_single = 0;
     d_single = 0;
     return(concat([if(p_single,"","("),
                    pol_ascending_str(p),
                    if(p_single,"",")"),
                    "/",
                    if(d_single,"","("),
                    pol_ascending_str(d),
                    if(d_single,"",")")
                   ])));
  if(poldegree(p) <= 0, return(Str(p)));
  my(str="");
  for(i=0,poldegree(p),
     my(coeff=polcoeff(p,i));
     if(coeff == 0, next());
     if(str!="",
        if(real(coeff)<0 || (real(coeff)==0 && imag(coeff)<0),
           str=concat(str," - "); coeff = -coeff,
           str=concat(str," + ")));
     str = concat([str,coeff*variable(p)^i]));
  str;
}

pol_ascending_print(x) = print(pol_ascending_str(x));

\\ str = pol_ascending_str( (x^2 + 1/2*x + 1)/(2*x^3 + x - 1) );
\\ print("str = "str);
\\ 
\\ str = pol_ascending_str( ((-1/4 + 1/4*I)*x^2 + (1/8 + 1/8*I))/(x^3 - 1/4*I*x + (1/8 + 1/8*I)) );
\\ print("str = "str);
\\ 
\\ str = pol_ascending_str( (x^2)/(2*x^3 + x - 1) );
\\ print("str = "str);

